
(* 
 * fac : int -> int
 * REQUIRES: n >= 0
 * ENSURES: fac n ==> n!
 *)
fun fac (n:int) : int =
  if n = 0 
  then 1 
  else n * fac (n - 1)







exception Negative of int


(*
 * safeFac : int -> int
 * REQUIRES: true
 * ENSURES: safeFac n ==> n! for n >= 0
 *  otherwise raises exception Negative
 *)
fun safeFac (n:int) : int = 
  if n < 0 
  then raise Negative n
  else if n = 0
  then 1
  else n * safeFac (n - 1)





(*
 * safeFac2 : int -> int
 * REQUIRES: true
 * ENSURES: safeFac2 n ==> n! for n >= 0
 *  otherwise raises exception Negative
 *)
fun safeFac2 (n:int) : int =
  if n < 0 
  then raise Negative n
  else fac n






(* 
 * extended : int -> int
 * REQUIRES: true
 * ENSURES: extended n ==> n! for n >= 0
 *  and extended n ==> ~((~n)!) for n < 0
 *)
fun extendedFac (n:int) : int = 
  safeFac2 n 
  handle Negative m => ~ (safeFac2 (~m))



